Bug 1314792 - [GSS](6.4.z) mod_cluster session drain does not end
[GSS](6.4.z) mod_cluster session drain does not end
Status: CLOSED CURRENTRELEASE
Product: JBoss Enterprise Application Platform 6
Classification: JBoss
Component: mod_cluster (Show other bugs)
6.4.6
All Unspecified
urgent Severity high
: CR1
: EAP 6.4.8
Assigned To: baranowb
Michal Karm Babacek
:
Depends On:
Blocks: 1321090 1324903 1258395 eap648-payload
  Show dependency treegraph
 
Reported: 2016-03-04 08:57 EST by Aaron Ogburn
Modified: 2017-01-17 07:34 EST (History)
8 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2017-01-17 07:34:22 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)


External Trackers
Tracker ID Priority Status Summary Last Updated
JBoss Issue Tracker JBEAP-3969 Blocker Verified (7.0.z) Session draining always takes maximum configured timeout 2017-10-20 14:50 EDT
JBoss Issue Tracker MODCLUSTER-478 Major Resolved Session draining always takes maximum configured timeout since listener is always notified before session is removed 2017-10-20 14:50 EDT
JBoss Issue Tracker WFLY-6294 Blocker Resolved Session draining always takes maximum configured timeout 2017-10-20 14:50 EDT
Red Hat Knowledge Base (Solution) 2186601 None None None 2016-03-04 08:59 EST

  None (edit)
Description Aaron Ogburn 2016-03-04 08:57:42 EST
Description of problem:

mod_cluster uses a session listener to be notified when a session expires during session draining shutdown waits. That listener is not properly added so it is not invoked.

But even if it were invoked, it would not allow the session drain to end.  JBossWeb invokes session listeners before the session is removed, so after the listener is invoked, mod_cluster still sees an active session and continues to wait.

mod_cluster's session drain needs to be redesigned some or JBossWeb needs to fire session listeners after the session is removed.


How reproducible:

Very


Steps to Reproduce:
1. Run ha profile with an increased session drain stop timeout:

            <mod-cluster-config advertise-socket="modcluster" stop-context-timeout="300" connector="default" session-draining-strategy="ALWAYS">

2. create a session in an app
3. stop jboss
4. invalidate that session
5. note shutdown drain wait doesn't end

Actual results:

Session draining does not end when all sessions are invalidated.


Expected results:

Session draining does end when all sessions are invalidated.
Comment 2 Mike McCune 2016-03-28 18:44:25 EDT
This bug was accidentally moved from POST to MODIFIED via an error in automation, please see mmccune@redhat.com with any questions
Comment 5 Michal Karm Babacek 2016-03-31 20:20:34 EDT
I confirm that f38dce459 1.2.12.Final-SNAPSHOT upstream mod_cluster fixes the issue, although we need a productized artifact...
Comment 9 Michael Cada 2016-05-10 04:11:12 EDT
Verified with EAP 6.4.8.CP.CR2
Comment 10 Petr Penicka 2017-01-17 07:34:22 EST
Retroactively bulk-closing issues from released EAP 6.4 cumulative patches.

Note You need to log in before you can comment on or make changes to this bug.